﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{

	import com.google.maps.controls.ZoomControl;
	import com.google.maps.controls.PositionControl;
	import com.google.maps.controls.ControlPosition;
	import com.google.maps.controls.MapTypeControl;
	import com.demonsters.debugger.MonsterDebugger;
	import com.google.maps.Color;
	import com.google.maps.overlays.MarkerOptions;
	import com.google.maps.overlays.Marker;
	import com.google.maps.Map;
	import com.google.maps.MapEvent;	
	import com.google.maps.services.Placemark;
	import com.google.maps.services.GeocodingEvent;
	import com.google.maps.services.ClientGeocoder;
	import com.google.maps.MapType;
	import com.google.maps.LatLng;
	import com.google.maps.MapOptions;
	
	
	import flash.geom.Point;
	import flash.display.Sprite;
	import flash.events.Event;	
	import flash.events.MouseEvent;	


	import com.actionscriptfacile.ui.text.UITextField;
	import com.as3facile.DefaultButton;	

	
	/**
	 * Géolocalisation d'un mobile Android avec API Flash Google Map.
	 * 
	 */
	public class MainGeolocalisation extends Sprite
	{
		// clé API Google Map, à générer ici : http://code.google.com/apis/oGoogleMaps/signup.html
		private static const API_KEY : String = "ABQIAAAAUUPM2YTPbv1Mom3_EFyc_BTtbp2H4cHMNwiMGXghqrSl3NkR7xQBAD5jpCQywkbRokxaxG5SvJ5TQQ";
		
		// url du site internet (obligatoire) associé à la clé API pour utiliser  Google Map sur Android AIR
		private static const API_URL : String = "http://www.actionscript-facile.com/";
		
		private var oGoogleMap : Map;// l'objet carte google
		private var bMapReady : Boolean;// la carte google est prête ?
		
		private var oClientGeocoder : ClientGeocoder;// pour afficher l'adresse précise des coordonnées latitude / longitude
		
		// objets affichage textes
		private var oTxtLatitudeInput : UITextField;
		private var oTxtLongitudeInput : UITextField;
		private var oTxtInfos : UITextField;

		
		/**
		 * Constructeur.
		 * 
		 */
		public function MainGeolocalisation()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");

			// texte informatif
			oTxtInfos = this.addText("Chargement en cours...");
			oTxtInfos.x = 260;
			oTxtInfos.y = 60;
			oTxtInfos.maxWidth = 280;
			oTxtInfos.width = 280;
			oTxtInfos.multiline = true;
			oTxtInfos.selectable = true;
			oTxtInfos.wordWrap = true;
			this.addChild(oTxtInfos);
			
			this.addGeolocalisation();
			this.addGoogleMap();
		}


		/**
		 * Récupère les informations latitude et longitude saisies par l'utilisateur.
		 * 
		 */
		private function addGeolocalisation() : void
		{
			var oTxtLatitude:UITextField = this.addText("Renseignez la latitude : ");
			oTxtLatitude.x = 20;
			oTxtLatitude.y = 20;
			this.addChild(oTxtLatitude);
			
			oTxtLatitudeInput = this.addTextInput("47.212244");
			oTxtLatitudeInput.x = oTxtLatitude.x + oTxtLatitude.width;
			oTxtLatitudeInput.y = oTxtLatitude.y;
			this.addChild(oTxtLatitudeInput);
			
			
			var oTxtLongitude:UITextField = this.addText("Renseignez la longitude : ");
			oTxtLongitude.x = oTxtLatitude.x;
			oTxtLongitude.y = oTxtLatitude.y + 40;
			this.addChild(oTxtLongitude);
			
			oTxtLongitudeInput = this.addTextInput("-1.520196");
			oTxtLongitudeInput.x = oTxtLatitude.x + oTxtLongitude.width;
			oTxtLongitudeInput.y = oTxtLongitude.y;
			this.addChild(oTxtLongitudeInput);
			
			
			var oBtnStart:DefaultButton = new DefaultButton();
			oBtnStart.getObject().label = "Valider !";
			oBtnStart.getObject().x = oTxtLongitudeInput.x + oTxtLongitudeInput.maxWidth + 50;
			oBtnStart.getObject().y = oTxtLongitude.y - 33;
			oBtnStart.getObject().addEventListener ( MouseEvent.CLICK, onReceivePosition );
			this.addChild(oBtnStart);
		}


		
		
		/**
		 * Ajout de la gestion de la carte Google Map.
		 * 
		 */
		private function addGoogleMap() : void
		{
			oGoogleMap = new Map();
			oGoogleMap.y = 100;
			oGoogleMap.key = API_KEY;
			oGoogleMap.url = API_URL;
			oGoogleMap.sensor = "false";// détection de la position via un GPS
			oGoogleMap.setSize( new Point(stage.stageWidth, stage.stageHeight - oGoogleMap.y) );// taille de la carte
			
			oGoogleMap.addEventListener(MapEvent.MAP_READY, onMapReady);
			oGoogleMap.addEventListener(MapEvent.MAP_PREINITIALIZE, onMapInit);
			//oGoogleMap.addEventListener(MapMouseEvent.CLICK, onMapClick);
			//oGoogleMap.addEventListener(MapMoveEvent.MOVE_END, onMapMoveEnd);
			
			this.addChild(oGoogleMap);
		}
		
		
		/**
		 * La carte google est prête à être utilisée.
		 * 
		 */
		private function onMapReady(event : Event) : void
		{
			oTxtInfos.text = "Carte Google Map prête";
			MonsterDebugger.trace(this, "Carte Google Map prête");
			
			oClientGeocoder = new ClientGeocoder();// pour afficher l'adresse précise des coordonnées latitude / longitude
			oClientGeocoder.addEventListener(GeocodingEvent.GEOCODING_SUCCESS, onGeocodingSuccess);
			oClientGeocoder.addEventListener(GeocodingEvent.GEOCODING_FAILURE, onGeocodingError);
			
			var bottomRight : ControlPosition = new ControlPosition(ControlPosition.ANCHOR_BOTTOM_RIGHT, 16, 10);
			var myMapTypeControl : MapTypeControl = new MapTypeControl();
			myMapTypeControl.setControlPosition(bottomRight);
			oGoogleMap.addControl(myMapTypeControl);
			
			// active les contrôles sur la carte 
			oGoogleMap.addControl(new ZoomControl());
			oGoogleMap.addControl(new PositionControl());

			
			bMapReady = true;
		}
		

		/**
		 * Erreur de décodage des coordonnées latitude et longitude.
		 * 
		 */
		private function onGeocodingError(event : GeocodingEvent) : void
		{
			oTxtInfos.text = "Erreur de décodage des coordonnées latitude et longitude !!!";
			MonsterDebugger.trace(this, "Erreur de décodage des coordonnées latitude et longitude !!!");
		}
		

		/**
		 * Coordonnées latitude et longitude décodées.
		 * 
		 */
		private function onGeocodingSuccess(event : GeocodingEvent) : void
		{
			// si l'adresse est trouvée
			if(event.response.placemarks.length > 0)
			{
				var sAdress:String = (event.response.placemarks[0] as Placemark).address;
				oTxtInfos.text = "Vous êtes situé : "+sAdress;
			}
			else
				oTxtInfos.text = "Adresse inexistante !!!";
			
		}
		
				
		/**
		 * Initialisation de la carte.
		 * 
		 */
		private function onMapInit(event : MapEvent) : void
		{
			var myMapOptions : MapOptions = new MapOptions();
			myMapOptions.zoom = 15;
			myMapOptions.center = new LatLng(45.779017,3.086987);// ville de Clermont Ferrand
			
			/*
			Les différents types de cartes
			NORMAL_MAP_TYPE - vue par défaut
			SATELLITE_MAP_TYPE - affiche les images satellite de Google Earth 
			HYBRID_MAP_TYPE - affiche un mixte entre le mode normal et les imagse satellites
			PHYSICAL_MAP_TYPE - affiche le relief de la terre.
			DEFAULT_MAP_TYPES - un tableau avec les différents types pour les processus itératifs.
 			*/
			myMapOptions.mapType = MapType.NORMAL_MAP_TYPE;
			
			oGoogleMap.setInitOptions(myMapOptions);
		}
			
		
		/**
		 * Réception de la position du mobile.
		 * latitude et longitude.
		 * 
		 */
		private function onReceivePosition(event : Event) : void
		{
			var nLatitude:Number = Number(oTxtLatitudeInput.text);
			var nLongititude:Number = Number(oTxtLongitudeInput.text);
			
			// si la carte google est prêt
			if( bMapReady )
			{
				// affiche la position du mobile sur la carte
				var oLatitudeLongitude:LatLng = new LatLng(nLatitude, nLongititude);
				
				// coordonnées de la zone - niveau de zoom - le type de carte (satellite...)
				oGoogleMap.setCenter(oLatitudeLongitude, 16, MapType.HYBRID_MAP_TYPE);
				
				// trouve l'adresse précise correspondant aux coordonnées latitude et longitude
				oClientGeocoder.reverseGeocode( oLatitudeLongitude );
				
				// ajoute un bouton de navigation
				var oMarkerOptions:MarkerOptions = new MarkerOptions
				({
					fillStyle:{color:Color.GREEN,alpha: 0.8},
					hasShadow: true,
					radius: 12,
					clickable: false,
					draggable: true,
					tooltip: "Vous êtes ici"
				});
				
				var oMarker : Marker = new Marker(oLatitudeLongitude, oMarkerOptions);
				oGoogleMap.addOverlay( oMarker );
			}
		}
		
	
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			
			oTxtField.selectable = false;
			oTxtField.alignLeft(); // centre le texte
			oTxtField.convertToDynamic(); // centre le texte
			oTxtField.maxWidth = oTxtField.width = 150;
			oTxtField.changeFormat("size", 12);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			return oTxtField;
		}
		
		
		/**
		 * Création d'un champ texte de type input.
		 * 
		 */
		private function addTextInput(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.autoSizeNone();
			oTxtField.border = true;
			oTxtField.borderColor = 0x006f77;
			oTxtField.convertToInput();
			oTxtField.maxWidth = oTxtField.width = 80;
			oTxtField.maxHeight = oTxtField.height = 20;
			oTxtField.selectable = true;
			oTxtField.changeFormat("bold", true);// changement de la taille de la police du texte
			oTxtField.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x00C5DF);// changement de la couleur
			
			return oTxtField;	 
		}
		

	}
}
