/**
 * Out by Grant Skinner. May 22, 2010
 * Visit www.gskinner.com/blog for documentation, updates and more free code.
 *
 *
 * Copyright (c) 2010 Grant Skinner
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 **/
package com.debug
{
	import flash.display.Stage;
	import flash.ui.Keyboard;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.text.TextField;

	public class Out
	{
		private static var bCtrlOk : Boolean = false;// touche controle enfoncée
		private static var bSeeDebug : Boolean = true;// affiche le texte de debug
		private static var bReady : Boolean = false;// classe initialisée
		
		public static var stage : Stage;
		public static var handler : Function;
		public static var textField : TextField;
		public static var maxLength : uint = 5000;


		/**
		 * Initialisation pour l'écoute de la combinaison de touches.
		 * 
		 */
		private static function init() : void
		{
			stage.addEventListener(KeyboardEvent.KEY_DOWN, stageKeyDown);
			stage.addEventListener(KeyboardEvent.KEY_UP, stageKeyUp);
			stage.addEventListener(Event.ENTER_FRAME, stageEnterFrame);
		}
		

		/**
		 * Touche relâchée.
		 * 
		 */
		private static function stageKeyUp(e : KeyboardEvent) : void
		{
			if (e.keyCode == Keyboard.CONTROL) bCtrlOk = false;
		}


		/**
		 * Touche appuyée.
		 * 
		 */
		private static function stageKeyDown(e : KeyboardEvent) : void
		{
			if (e.keyCode == Keyboard.CONTROL) bCtrlOk = true;
			if (e.keyCode == Keyboard.D && bCtrlOk == true) bSeeDebug = !bSeeDebug;
		}


		/**
		 * Mise à jour de la visibilité du Text de Debug
		 */
		private static function stageEnterFrame(e : Event) : void
		{
			Out.textField.visible = bSeeDebug;
		}


		public static function trace(...rest : Array) : void
		{
			if (bReady == false)
			{
				Out.init();
				bReady = true;
			}

			if (handler.apply(null, rest) != false && textField)
			{
				var txt : String = (textField.text + rest.join(" ") + "\n");
				textField.text = txt.substr(txt.length - maxLength);
				textField.scrollV = textField.maxScrollV;
			}
		}
	}
}

com.debug.Out.handler = trace;